## net.sf.saxon.value
Class IntegerRange

    java.lang.Object
      net.sf.saxon.value.Value
          net.sf.saxon.value.IntegerRange

All Implemented Interfaces:
  Expression, java.io.Serializable, ValueRepresentation

public class IntegerRange
extends Value

This class represents a sequence of consecutive ascending integers, for example 1 to 50. The integers must be within the range of a Java long.

See Also:
  Serialized Form

Field Summary
`long` `end`
`long` `start`

Fields inherited from class net.sf.saxon.value.Value
`EMPTY_CLASS_ARRAY`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`IntegerRange(long start, long end)`

Method Summary
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic display of the expression
`int` `getCardinality()` Determine the cardinality
`long` `getEnd()`
`int` `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`ItemType` `getItemType(TypeHierarchy th)` Determine the data type of the items in the expression, if possible
`int` `getLength()` Get the length of the sequence
`long` `getStart()`
`Item` `itemAt(int n)` Get the n'th item in the sequence (starting from 0).
`SequenceIterator` `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.

Methods inherited from class net.sf.saxon.value.Value

`asItem, asIterator, asValue, checkPermittedContents, collapseWhitespace, convert, convertJavaObjectToXPath, convertToJava, effectiveBooleanValue, equals, evaluateAsString, evaluateItem, getDependencies, getIterator, getParentExpression, getSpecialProperties, getStringValue, hashCode, iterateSubExpressions, makeQNameValue, normalizeWhitespace, optimize, process, promote, reduce, schemaEquals, simplify, stringToNumber, toString, trimWhitespace, typeCheck`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### start

    public long start

### end

    public long end

Constructor Detail

### IntegerRange

    public IntegerRange(long start,
                        long end)

Method Detail

### getStart

    public long getStart()

### getEnd

    public long getEnd()

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.

  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items in the expression, if possible

  Specified by:
    `getItemType` in interface `Expression`
  Overrides:
    `getItemType` in class `Value`
  Parameters:
    `th` -
  Returns:
    AnyItemType (not known)

### getCardinality

    public int getCardinality()

  Determine the cardinality

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `Value`

### itemAt

    public Item itemAt(int n)
                throws XPathException

  Get the n'th item in the sequence (starting from 0). This is defined for all Values, but its real benefits come for a sequence Value stored extensionally (or for a MemoClosure, once all the values have been read)

  Overrides:
    `itemAt` in class `Value`
  Throws:
    `XPathException`

### getLength

    public int getLength()
                  throws XPathException

  Get the length of the sequence

  Overrides:
    `getLength` in class `Value`
  Throws:
    `XPathException`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic display of the expression

  Specified by:
    `display` in interface `Expression`
  Overrides:
    `display` in class `Value`